require "behaviours/chaseandattack"
require "behaviours/runaway"
require "behaviours/wander"
require "behaviours/doaction"
require "behaviours/attackwall"
require "behaviours/chattynode"

-- SAT TALK
local LEIF_TALK_SAT_COMBAT = {"MURDERER!","MONSTER!","I'LL MAKE YOU PAY!"}
local LEIF_TALK_SAT_WANDER = {" "}

local LeifBrain = Class(Brain, function(self, inst)
    Brain._ctor(self, inst)
end)

function LeifBrain:OnStart()

    local clock = GetClock()
	if GetPlayer().prefab ~= "sat" then 
		local root =
        PriorityNode(
        {
			AttackWall(self.inst),
            ChaseAndAttack(self.inst),
            Wander(self.inst)            
        },1)    
		self.bt = BT(self.inst, root)
	else
		local root =
			PriorityNode(
			{
				ChattyNode(self.inst, LEIF_TALK_SAT_COMBAT,
					AttackWall(self.inst)),
				ChattyNode(self.inst, LEIF_TALK_SAT_COMBAT,
					ChaseAndAttack(self.inst)),
				ChattyNode(self.inst, LEIF_TALK_SAT_WANDER,
					Wander(self.inst))            
			},1)		
		self.bt = BT(self.inst, root)
	end	
end

return LeifBrain